diff -c -N -r vtun-2.6/auth.h vtun-3.0-RvR/auth.h
*** vtun-2.6/auth.h	Tue Mar 28 19:19:39 2000
--- vtun-3.0-RvR/auth.h	Fri Oct 10 13:41:05 2003
***************
*** 20,30 ****
   * auth.h,v 1.1.1.2 2000/03/28 17:19:39 maxk Exp
   */ 
  
! #define VTUN_CHAL_SIZE	 16	
  
! #define ST_INIT  0
! #define ST_HOST  1
! #define ST_CHAL  2
  
  struct vtun_host * auth_server(int fd);
  int auth_client(int fd, struct vtun_host *host);
--- 20,40 ----
   * auth.h,v 1.1.1.2 2000/03/28 17:19:39 maxk Exp
   */ 
  
! #define VTUN_CHAL_SIZE	       16
! #define VTUN_RESP_SIZE         16
! #define VTUN_RESP_HASH_SIZE    20
! #define VTUN_CHALRESP_MAXSIZE  20
  
! #define ST_INIT      0
! #define ST_HOST      1
! #define ST_CHAL_SRV  2
! #define ST_CHAL_CLI  3
  
  struct vtun_host * auth_server(int fd);
  int auth_client(int fd, struct vtun_host *host);
+ 
+ int open_cryptoken (void);
+ int close_cryptoken (void);
+ int rndgen_cryptoken (char *buf, int size);
+ int challenge_cryptoken (char *keydir, unsigned long keynum, char chal [VTUN_CHAL_SIZE], char resp [VTUN_RESP_SIZE]);
+ int login_cryptoken (char *pin);
diff -c -N -r vtun-2.6/cfg_file.y vtun-3.0-RvR/cfg_file.y
*** vtun-2.6/cfg_file.y	Thu Jun  6 04:53:14 2002
--- vtun-3.0-RvR/cfg_file.y	Fri Oct 10 13:41:06 2003
***************
*** 29,34 ****
--- 29,35 ----
  #include <stdarg.h>
  
  #include <syslog.h>
+ #include <dlfcn.h>
  
  #include "compat.h"
  #include "vtun.h"
***************
*** 76,81 ****
--- 77,83 ----
  %token K_MULTI K_SRCADDR K_IFACE K_ADDR
  %token K_TYPE K_PROT K_COMPRESS K_ENCRYPT K_KALIVE K_STAT
  %token K_UP K_DOWN K_SYSLOG K_IPROUTE
+ %token K_CRYPTOKEN K_KEYNUM K_KEYDIR
  
  %token <str> K_HOST K_ERROR
  %token <str> WORD PATH STRING
***************
*** 107,112 ****
--- 109,116 ----
  	  	  memcpy(parse_host, &default_host, sizeof(struct vtun_host));
  		  parse_host->host = strdup($1);
  		  parse_host->passwd = NULL;
+ 		  parse_host->keydir = NULL;
+ 		  parse_host->keynum = ~0L;
  
  		  /* Copy local address */
  		  copy_addr(parse_host, &default_host);
***************
*** 118,125 ****
      '{' host_options '}'
  		{
  		  /* Check if session definition is complete */ 
! 		  if (!parse_host->passwd) {
! 		  	cfg_error("Ignored incomplete session definition '%s'", parse_host->host);
  			free_host(parse_host, NULL);			
  			free(parse_host);
  		  } else {
--- 122,133 ----
      '{' host_options '}'
  		{
  		  /* Check if session definition is complete */ 
! 		  if ((!vtun.epasslib) && (!parse_host->passwd)) {
! 		  	cfg_error("Ignored password-less session definition '%s'", parse_host->host);
! 			free_host(parse_host, NULL);			
! 			free(parse_host);
! 		  } else if (vtun.epasslib && (parse_host->keynum == ~0L)) {
! 		  	cfg_error("Ignored key-less session definition '%s'", parse_host->host);
  			free_host(parse_host, NULL);			
  			free(parse_host);
  		  } else {
***************
*** 183,188 ****
--- 191,206 ----
  
    | K_SYSLOG  syslog_opt
  
+   | K_CRYPTOKEN STRING	{
+ 			  // Ignore argument for now (may become token type)
+ 			  vtun.epasslib = dlopen ("/usr/lib/libepassapi.so", RTLD_NOW);
+ 			  if (!vtun.epasslib) {
+ 			    cfg_error ("Unavailable ePass1000 driver: %s", dlerror ());
+ 			    YYABORT;
+ 			  }
+ 			}
+ 
+ 
    | K_ERROR		{
  			  cfg_error("Unknown option '%s'",$1);
  			  YYABORT;
***************
*** 216,225 ****
--- 234,264 ----
   * could be strduped from default_host */
  host_option: '\n'
    | K_PASSWD WORD 	{
+ 			  if (vtun.epasslib) {
+ 			    cfg_error ("Unexpected password, there is a cryptoken driver");
+ 			    YYABORT;
+ 			  }
  			  free(parse_host->passwd);
  			  parse_host->passwd = strdup($2);
  			}
  
+   | K_KEYNUM NUM	{
+ 			  if (!vtun.epasslib) {
+ 			    cfg_error ("Cannot accept keynum without cryptoken driver");
+ 			    YYABORT;
+ 			  }
+ 			  parse_host->keynum = $2;
+ 			}
+ 
+   | K_KEYDIR STRING	{
+ 			  if (!vtun.epasslib) {
+ 			    cfg_error ("Cannot accept keydir without cryptoken driver");
+ 			    YYABORT;
+ 			  }
+ 			  free (parse_host->keydir);
+ 			  parse_host->keydir = strdup ($2);
+ 			}
+ 
    | K_DEVICE WORD 	{
  			  free(parse_host->dev);
  			  parse_host->dev = strdup($2);
***************
*** 256,261 ****
--- 295,302 ----
  			compress
  
    | K_ENCRYPT NUM 	{  
+ 			  /* Future versions: allow AES / Blowfish distinction
+ 			   */
  			  if( $2 )
  			     parse_host->flags |= VTUN_ENCRYPT;
  			  else
diff -c -N -r vtun-2.6/cfg_kwords.h vtun-3.0-RvR/cfg_kwords.h
*** vtun-2.6/cfg_kwords.h	Sat Dec 29 18:01:01 2001
--- vtun-3.0-RvR/cfg_kwords.h	Fri Oct 10 13:41:06 2003
***************
*** 57,62 ****
--- 57,65 ----
     { "keepalive",K_KALIVE }, 
     { "stat",	 K_STAT }, 
     { "syslog",   K_SYSLOG },
+    { "cryptoken",K_CRYPTOKEN },
+    { "keydir",   K_KEYDIR },
+    { "keynum",   K_KEYNUM },
     { NULL , 0 }
  };
  
***************
*** 80,84 ****
--- 83,94 ----
     { "inetd",	 VTUN_INETD },
     { "stand",	 VTUN_STAND_ALONE },
     { "keep",     VTUN_PERSIST_KEEPIF },
+    { "epass1000",1 }, // No distinction between tokens at this time
+    { "blowfish", 1 }, // For now, an alias for "enable"
+ /* Useful future change + extensions, when OpenSSL supports AES:
+    { "blowfish", VTUN_BLOWFISH },
+    { "aes",      VTUN_AES },
+    { "rijndael", VTUN_AES },
+  */
     { NULL , 0 }
  };
diff -c -N -r vtun-2.6/configure.in vtun-3.0-RvR/configure.in
*** vtun-2.6/configure.in	Fri Dec 20 18:13:03 2002
--- vtun-3.0-RvR/configure.in	Fri Oct 10 14:15:09 2003
***************
*** 65,70 ****
--- 65,77 ----
     LIBS="$LIBS -L$withval" 
  )
  
+ dnl Build in dynamic support for ePass1000 (shipping without lib is possible)
+ AC_ARG_WITH(epass,
+    --with-epass		Support ePass1000 cryptographic token (README.Crypto)
+    CFLAGS="$CFLAGS -DUSE_EPASS"
+    LIBS="$LIBS -ldl"
+ )
+ 
  dnl Guess host type.
  AC_CANONICAL_HOST
  AC_CANONICAL_SYSTEM
diff -c -N -r vtun-2.6/lfd_encrypt.c vtun-3.0-RvR/lfd_encrypt.c
*** vtun-2.6/lfd_encrypt.c	Mon Dec 16 22:40:46 2002
--- vtun-3.0-RvR/lfd_encrypt.c	Fri Oct 10 14:27:10 2003
***************
*** 30,36 ****
   * This lfd_encrypt module uses MD5 to create 128 bits encryption
   * keys and BlowFish for actual data encryption.
   * It is based on code written by Chris Todd<christ@insynq.com> with 
!  * several improvements and modifications by me.  
   */
  
  #include "config.h"
--- 30,58 ----
   * This lfd_encrypt module uses MD5 to create 128 bits encryption
   * keys and BlowFish for actual data encryption.
   * It is based on code written by Chris Todd<christ@insynq.com> with 
!  * several improvements and modifications by Maxim Krasnyansky.  
!  * After that, Rick van Rein changed encryption mode from ECB to CBC,
!  * to deminish the chances of replay attacks.  This works optimally
!  * on TCP connections, where delivery order is known so that the chain
!  * can be continued between tunnelled packets.
!  */
! 
! /* Cryptographic improvements by Rick van Rein <rick@openfortress.nl>
!  *
!  * ECB mode was used, but it is not safe because every single 8-bit package
!  * could be replaced independently.  CBC is now used.  In addition, support
!  * for evolving ciphers was made using the initialisation vectors for that
!  * mode of operation.
!  *
!  * The prefix used to be length + zeroes to pad it to 8-byte blocks.  This
!  * would however give away a lot of information if the information there
!  * had been fixed bytes 08 00 00 00 00 00 00 00.  A simple improvement was
!  * made by replacing fill-up zeroes with psuedo-random bytes.  And to ensure
!  * that predicability of protocol headers plus zeroed-out initialisation
!  * vectors at the start of a transmission would cause a similar threat, we
!  * ensured that at least 8 bytes of randomness was prefixed to each packet.
!  * A small price to pay for security, and much simpler than constant
!  * tracking of IV's (which would be complicated in UDP mode).
   */
  
  #include "config.h"
***************
*** 51,56 ****
--- 73,79 ----
  #ifndef __APPLE_CC__
  /* OpenSSL includes */
  #include <openssl/md5.h>
+ #include <openssl/rand.h>
  #include <openssl/blowfish.h>
  #else /* YAY - We're MAC OS */
  #include <sys/md5.h>
***************
*** 70,76 ****
        return -1;
     }
  
!    BF_set_key(&key, ENC_KEY_SIZE, MD5(host->passwd,strlen(host->passwd),NULL));
  
     vtun_syslog(LOG_INFO, "BlowFish encryption initialized");
     return 0;
--- 93,100 ----
        return -1;
     }
  
!    BF_set_key(&key, VTUN_SESKEY_SIZE, host->seskey);
!    memset (host->seskey, 0, VTUN_SESKEY_SIZE); // Wipe from memory
  
     vtun_syslog(LOG_INFO, "BlowFish encryption initialized");
     return 0;
***************
*** 85,118 ****
  int encrypt_buf(int len, char *in, char **out)
  { 
     register int pad, p;
!    register char *in_ptr = in, *out_ptr = enc_buf;
  
!    /* 8 - ( len % 8 ) */
!    pad = (~len & 0x07) + 1; p = 8 - pad;
  
!    memset(out_ptr, 0, pad);
!    *out_ptr = (char) pad;
!    memcpy(out_ptr + pad, in_ptr, p);  
!    BF_ecb_encrypt(out_ptr, out_ptr, &key, BF_ENCRYPT);
!    out_ptr += 8; in_ptr += p; 
!    len = len - p;
  
!    for (p=0; p < len; p += 8)
!       BF_ecb_encrypt(in_ptr + p,  out_ptr + p, &key, BF_ENCRYPT);
  
     *out = enc_buf;
!    return len + 8;
  }
  
  int decrypt_buf(int len, char *in, char **out)
  {
     register int p;
  
!    for (p = 0; p < len; p += 8)
!       BF_ecb_encrypt(in + p, in + p, &key, BF_DECRYPT);
  
!    p = *in;
!    if (p < 1 || p > 8) {
        vtun_syslog(LOG_INFO, "decrypt_buf: bad pad length");
        return 0;
     }
--- 109,142 ----
  int encrypt_buf(int len, char *in, char **out)
  { 
     register int pad, p;
!    char preamble [16];
!    unsigned char iv [8];
  
!    /* 16 - ( len % 8 ) */
!    pad = (~len & 0x07) + 9; p = 16 - pad;
  
!    RAND_pseudo_bytes (preamble, pad); // Scramble the blowfish outcome
!    preamble [8] = (char) pad;
  
!    memset (iv, 0, 8);
!    memcpy(preamble + pad, in, p);  
!    BF_cbc_encrypt (preamble, enc_buf,      16,      &key, iv, BF_ENCRYPT);
!    BF_cbc_encrypt (in + p,   enc_buf + 16, len - p, &key, iv, BF_ENCRYPT);
  
     *out = enc_buf;
!    return len + pad;
  }
  
  int decrypt_buf(int len, char *in, char **out)
  {
     register int p;
+    unsigned char iv [8];
  
!    memset (iv, 0, 8);
!    BF_cbc_encrypt (in, in, len, &key, iv, BF_DECRYPT);
  
!    p = in [8];
!    if (p < 9 || p > 16) {
        vtun_syslog(LOG_INFO, "decrypt_buf: bad pad length");
        return 0;
     }
diff -c -N -r vtun-2.6/main.c vtun-3.0-RvR/main.c
*** vtun-2.6/main.c	Mon Apr 29 15:54:55 2002
--- vtun-3.0-RvR/main.c	Fri Oct 10 13:41:06 2003
***************
*** 36,41 ****
--- 36,42 ----
  #include "vtun.h"
  #include "lib.h"
  #include "compat.h"
+ #include "auth.h"
  
  /* Global options for the server and client */
  struct vtun_opts vtun;
***************
*** 54,59 ****
--- 55,63 ----
       struct vtun_host *host = NULL;
       struct sigaction sa;
       char *hst;
+      char testchal [VTUN_CHAL_SIZE];
+      char testresp [VTUN_RESP_SIZE];
+      int attempts;
  
       /* Configure default settings */
       svr = 0; daemon = 1; sock = 0; dofork = 1;
***************
*** 135,141 ****
  
  	vtun.svr_name = strdup(argv[optind]);
       } 
!       	
       /* 
        * Now fill uninitialized fields of the options structure
        * with default values. 
--- 139,156 ----
  
  	vtun.svr_name = strdup(argv[optind]);
       } 
! 
!      if (vtun.epasslib != NULL) {
!         if (open_cryptoken ()) {
! 	   perror ("Failed to access VPN token");
! 	   exit (1);
!         }
!         // Close immediately -- do not lock out other applications!
!         if (close_cryptoken ()) {
!            perror ("Failed to close VPN token after initial testing");
!         }
!      }
! 
       /* 
        * Now fill uninitialized fields of the options structure
        * with default values. 
***************
*** 189,197 ****
          client(host);
       }
  
       closelog();
! 	
!      return 0;
  }
  
  /* 
--- 204,215 ----
          client(host);
       }
  
+      if (vtun.epasslib != NULL) {
+         close_cryptoken ();
+      }
+ 
       closelog();
! 
  }
  
  /* 
diff -c -N -r vtun-2.6/vtun.h vtun-3.0-RvR/vtun.h
*** vtun-2.6/vtun.h	Sat Dec 29 18:01:01 2001
--- vtun-3.0-RvR/vtun.h	Fri Oct 10 13:41:05 2003
***************
*** 41,46 ****
--- 41,49 ----
  
  /* Max lenght of device name */
  #define VTUN_DEV_LEN  20 
+ 
+ /* Number of bytes in a session key */
+ #define VTUN_SESKEY_SIZE  20
   
  /* End of configurable part */
  
***************
*** 82,89 ****
  
  struct vtun_host {
     char *host;
!    char *passwd;
     char *dev;
  
     llist up;
     llist down;
--- 85,95 ----
  
  struct vtun_host {
     char *host;
!    char *passwd;     // For configfile-based auth/encrypt
!    unsigned long keynum;  // For token-based auth/encrypt
!    char *keydir;
     char *dev;
+    char seskey [VTUN_SESKEY_SIZE];
  
     llist up;
     llist down;
***************
*** 107,112 ****
--- 113,119 ----
     int ka_interval;
     int ka_failure;
  
+ 
     /* Source address */
     struct vtun_addr src_addr;
  
***************
*** 151,157 ****
  #define VTUN_BAD_FRAME  0x8000
  
  /* Authentication message size */
! #define VTUN_MESG_SIZE	50
  
  /* Support for multiple connections */
  #define VTUN_MULTI_DENY		0  /* no */ 
--- 158,164 ----
  #define VTUN_BAD_FRAME  0x8000
  
  /* Authentication message size */
! #define VTUN_MESG_SIZE	60
  
  /* Support for multiple connections */
  #define VTUN_MULTI_DENY		0  /* no */ 
***************
*** 184,189 ****
--- 191,198 ----
     int  svr_port;	 /* Server's port */
     int  svr_type;	 /* Server mode */
     int  syslog; 	 /* Facility to log messages to syslog under */
+    
+    void *epasslib;       /* Dynamically linked library for token support */
  };
  #define VTUN_STAND_ALONE	0 
  #define VTUN_INETD		1	
diff -c -N -r vtun-2.6/vtund.conf vtun-3.0-RvR/vtund.conf
*** vtun-2.6/vtund.conf	Mon Dec 16 18:20:50 2002
--- vtun-3.0-RvR/vtund.conf	Fri Oct 10 13:41:06 2003
***************
*** 56,65 ****
--- 56,69 ----
  #   firewall - Program for the firewall setup. 
  #
  # -----------
+ #   cryptoken - Use a cryptographic token.  Currently only "epass1000".
+ #
+ # -----------
  #  
  # Session options: 
  #
  #    passwd - Password for authentication.
+ #    keyname - A password-replacing reference to an on-token HMAC-MD5 key.
  #
  # -----------
  #    type - Tunnel type.
***************
*** 243,248 ****
--- 247,255 ----
    route 	/sbin/route;
    firewall 	/sbin/ipchains;
    ip		/sbin/ip;
+ 
+   # Use a cryptographic token as described in README.Crypto
+   # cryptoken "ePass1000";
  }
  
  # Default session options 
***************
*** 254,259 ****
--- 261,267 ----
  # TUN example. Session 'cobra'.
  cobra {
    passwd  Ma&^TU;	# Password
+   # keyname 12345;	# Alternatively use a cryptographic token
    type  tun;		# IP tunnel 
    proto udp;   		# UDP protocol
    compress  lzo:9;	# LZO compression level 9
***************
*** 271,276 ****
--- 279,285 ----
  # the same as above, but with iproute2 command
  cobra {
    passwd  Ma&^TU;	# Password
+   # keyname 12345;	# Alternatively use a cryptographic token
    type  tun;		# IP tunnel 
    proto udp;   		# UDP protocol
    compress  lzo:9;	# LZO compression level 9
***************
*** 290,295 ****
--- 299,305 ----
  # Ethernet example. Session 'lion'.
  lion {
    passwd  Ma&^TU;	# Password
+   # keyname 12345;	# Alternatively use a cryptographic token
    type  ether; 		# Ethernet tunnel
    device tap0; 		# Device tap0 
    proto udp;   		# UDP protocol
***************
*** 325,330 ****
--- 335,341 ----
  # PPP example. Session 'viper'.
  viper {	
    passwd  TTT$bio;	# Password
+   # keyname 12345;	# Alternatively use a cryptographic token
    compress  yes; 	# ZLIB compression level 1 
    encrypt  yes;		# Encryption
    up {
***************
*** 338,343 ****
--- 349,355 ----
  # Pipe example. Session 'backup'.
  backup {
    passwd OnlyME;	# Password
+   # keyname 12345;	# Alternatively use a cryptographic token
    type pipe;		# Pipe tunnel
    speed 256:128;	# Shaping speed 256K IN and 128K OUT.
    encrypt yes;		# Encryption
***************
*** 355,360 ****
--- 367,373 ----
  # anything :-). 
  sz {
    passwd  OnlyME;	# Password
+   # keyname 12345;	# Alternatively use a cryptographic token
    type  tty;		# TTY tunnel
    speed 64;		# Shaping speed 64K IN/OUT
    encrypt  yes;		# Encryption
***************
*** 388,393 ****
--- 401,407 ----
  # TUN example. Session 'cobra'. 
  cobra {
    passwd  Ma&^TU;	# Password
+   # keyname 12345;	# Alternatively use a cryptographic token
    device tun1; 		# Device tun1 
    persist yes;		# Persist mode 
    up {
***************
*** 400,405 ****
--- 414,420 ----
  # same as above, but with iproute2 command
  cobra {
    passwd  Ma&^TU;	# Password
+   # keyname 12345;	# Alternatively use a cryptographic token
    device tun1; 		# Device tun1 
    persist yes;		# Persist mode 
    up {
***************
*** 414,419 ****
--- 429,435 ----
  # Ethernet example. Session 'lion'. 
  lion {
    passwd  Ma&^TU;	# Password
+   # keyname 12345;	# Alternatively use a cryptographic token
    type  ether;		# Ethernet tunnel
    device tap1; 		# Device tap1 
    up {
***************
*** 433,438 ****
--- 449,455 ----
  # PPP example. Session 'viper'. 
  viper {
    passwd  TTT$bio; 	# Password
+   # keyname 12345;	# Alternatively use a cryptographic token
    up {
  	# Connection is Up 
  
***************
*** 444,449 ****
--- 461,467 ----
  # Pipe example. Session 'backup'.
  backup {
    passwd OnlyME;	# Password
+   # keyname 12345;	# Alternatively use a cryptographic token
    up {
  	# Connection is Up 
  
***************
*** 458,463 ****
--- 476,482 ----
  # anything :-).
  sz {
    passwd  OnlyME;	# Password
+   # keyname 12345;	# Alternatively use a cryptographic token
    up {
  	# Receive file via ZMODEM from the
  	# stdin(tty tunnel).
